//+------------------------------------------------------------------+
//|                                               !Multi forever.mq5 |
//|                                          Copyright 2012, Heroix  |
//|                                              http://www.         |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Heroix"
#property link      "http://www."
#property version   "1.00"

#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\AccountInfo.mqh>
#include <Trade\SymbolInfo.mqh>

CTrade mytrade;
CPositionInfo myposition;
CAccountInfo myaccount;
CSymbolInfo mysymbol;

enum ENUM_VOL_TYPE{                //     
   VOL_PRICE_OPEN = 1,             //  
   VOL_VOL_OR_PRICE = 2,           // ,    -   
   VOL_VOL_AND_PRICE = 3           //  ( )   
};

input string  Symbol1Name = "EURUSD",     //   1
              Symbol2Name = "GBPUSD";     //   2
              
input double  Koeff1=2,
              Koeff2=3,
              Lot   =0.1;                 // 
            

input ENUM_VOL_TYPE volume=3;         //    

input int    ATR   =144,
             MAslow=21,
             MAfast=8;

input ENUM_MA_METHOD MA_Method=MODE_SMMA;  // 
                                           // - MODE_SMA=0    
                                           // - MODE_EMA=1    
                                           // - MODE_SMMA=2    
                                           // - MODE_LWMA=3 -   
input ENUM_APPLIED_PRICE MA_Price=PRICE_WEIGHTED;            // 
                                           // - PRICE_CLOSE=0   
                                           // - PRICE_OPEN=1   
                                           // - PRICE_HIGH=2   
                                           // - PRICE_LOW=3   
                                           // - PRICE_MEDIAN=4  , (high+low)/2 
                                           // - PRICE_TYPICAL=5  , (high+low+close)/3 
                                           // - PRICE_WEIGHTED=6   , (high+low+close+close)/4 



//string Symbol3Name, Symbol4Name;

double Prosadka, B1[], B2[], BH1[], BH2[], Handle, Handle2, MP1, MP2, Loti2, P1, P2, P01, P02, Point1, Point2, Lot1,
       delta, delta0, Profit, deltaclose, deltaclose0, deltadol, deltadol0, LTV;
int Ordercontrol, Go1, Go2, Readyclose, flagclose, flagdol, Bar, A;


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
 
   Handle = iCustom (NULL, PERIOD_CURRENT, "Ind_2_Linep1", Symbol1Name, false, Symbol2Name, false, true,  volume, ATR, MAslow, MAfast,MA_Method, MA_Price);
   
   ArraySetAsSeries(B1,true);
   ArraySetAsSeries(B2,true);
   
   A=0;
   if(MQL5InfoInteger(MQL5_TESTING)==true) A=1;

//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  if(A=0) return;
  
//Comment (AccountInfoDouble (ACCOUNT_EQUITY)-AccountInfoDouble(ACCOUNT_BALANCE));

if(Bar!=Bars (Symbol(), Period()))
{
CopyBuffer(Handle,0,0,10, B1);
CopyBuffer(Handle,1,0,10, B2);
Bar=Bars (Symbol(), Period());
}

/*
Comment ("B1[1]-B2[2] = ", NormalizeDouble(B1[1],4)-NormalizeDouble(B2[1],4), 
"\n", "B1[2]-B2[2] = ", NormalizeDouble(B1[2],4)-NormalizeDouble(B2[2],4),
"\n", "Last trade value = ", LTV
);
*/

if (PositionsTotal()!=0)
{
 if(B1[1]<B2[1]&&B1[2]>B2[2])
  {if (myposition.Select(Symbol1Name)) mytrade.PositionClose(Symbol1Name);
   if (myposition.Select(Symbol2Name)) mytrade.PositionClose(Symbol2Name);
  }
 if (B1[1]>B2[1]&&B1[2]<B2[2])
  {if (myposition.Select(Symbol1Name)) mytrade.PositionClose(Symbol1Name);
   if (myposition.Select(Symbol2Name)) mytrade.PositionClose(Symbol2Name);
  }
}




if (PositionsTotal()==0)             // 
{ if (  MathAbs(B1[1]-B2[1]) < MathAbs(B1[2]-B2[2])  ) //
   {if(B1[1]<B2[1]&&B1[2]<B2[2] || B1[1]>B2[1]&&B1[2]>B2[2]) 
    {
     if(B1[1]>B2[1])
     {Orderopen (2, Symbol1Name, NormalizeDouble(Lot*Koeff1,2));
      Orderopen (1, Symbol2Name, NormalizeDouble(Lot*Koeff2,2));
      LTV= B1[1]-B2[1];
     }
    
    if(B1[1]<B2[1])
    {Orderopen (1, Symbol1Name, NormalizeDouble(Lot*Koeff1,2));
     Orderopen (2, Symbol2Name, NormalizeDouble(Lot*Koeff2,2));
     LTV= B1[1]-B2[1];
    }}}
}


} //   Start

//+-----------------   ------------------------------------------+
void Orderopen (int trade, string symbol, double Loti)
  {if (trade==0)
   return;
   
   double Price;
   ENUM_ORDER_TYPE Type;
   
   if (trade==1)
    {Type= ORDER_TYPE_BUY;
     Price=SymbolInfoDouble(symbol,SYMBOL_ASK);
    }
   else 
    {Type = ORDER_TYPE_SELL;
     Price=SymbolInfoDouble(symbol,SYMBOL_BID);
    }
   mytrade.PositionOpen(symbol,Type,Loti,Price,0,0,"Open");    
  return;
  }    